summaryrefslogtreecommitdiff
path: root/tests/setgid-check
diff options
context:
space:
mode:
Diffstat (limited to 'tests/setgid-check')
-rw-r--r--tests/setgid-check43
1 files changed, 43 insertions, 0 deletions
diff --git a/tests/setgid-check b/tests/setgid-check
new file mode 100644
index 0000000..adeefb6
--- /dev/null
+++ b/tests/setgid-check
@@ -0,0 +1,43 @@
+# -*- sh -*-
+# Disable the current test if the working directory seems to have
+# the setgid bit set.
+
+# Copyright (C) 2000, 2002, 2004, 2005 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
+
+# This test should be run in the temporary directory that ends
+# up being removed via the trap commands.
+
+cwd_is_setgid=no
+
+setgid_tmpdir=setgid-$$
+(umask 77; mkdir $setgid_tmpdir)
+p=`ls -ld $setgid_tmpdir|sed 's/ .*//'`
+rmdir $setgid_tmpdir
+case $p in
+ drwx------);;
+ drwx------+);;
+ drwxr-xr-x);; # Windows98 + DJGPP 2.03 + fileutils-4.1 does this.
+ *) cwd_is_setgid=yes;;
+esac
+if test $cwd_is_setgid = yes; then
+ cat <<EOF >&2
+$0: Since it looks like you're running this test in a directory with
+the setgid bit set, we're skipping this test.
+EOF
+ (exit 77); exit 77
+fi